// Weather.cpp: CWeather NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "keppen.h"
#include "Weather.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

CWeather::CWeather()
{

}

CWeather::~CWeather()
{

}

void CWeather::CalcStr(CString& str)
{
	if( 12*m_AR <= 0.5*m_r )
	{
		str = "BW";
		return;
	}
	if( 12*m_AR <= m_r )
	{
		str = "BS";
		return;
	}

	if( m_T[m_CLD] >= 18 )
	{
		if( m_AR >= 60 )
		{
			str = "Af";return;
		}
		if( (12*m_AR/2500)+(m_R[m_DRY]/60)>=1 )
		{
			str = "Am";return;
		}
		str = "Aw";
		return;
	}
	if( m_T[m_CLD] >= -3 )
	{
		if( type==0 )
		{
			if( m_T[m_HOT] >=22 )
			{
				str = "Cfa";return;
			}
			str = "Cfb";
			return;
		}
		if( type==1 )
		{
			str = "Cs";return;
		}
		str = "Cw";
		return;
	}
	if( m_T[m_HOT] >=10 )
	{
		if( type==0 )
		{
			str = "Df";return;
		}
		if( type==1 )
		{
			str = "Ds";return;
		}
		str = "Dw";
		return;
	}
	if( m_T[m_HOT] >= 0 )
	{
		str = "ET";return;
	}
	str = "EF";
}

void CWeather::Init()
{
	m_HOT=m_CLD=m_WET=m_DRY=1;
	m_AT=m_T[1];	m_AR=m_R[1];
	for( int i=2; i!=13; i++ )
	{
		m_AT+=m_T[i];
		m_AR+=m_R[i];
		if( m_T[m_HOT]<m_T[i] )
			m_HOT = i;
		if( m_R[m_WET]<m_R[i] )
			m_WET = i;
		if( m_T[m_CLD]>m_T[i] )
			m_CLD = i;
		if( m_R[m_DRY]>m_R[i] )
			m_DRY = i;
	}
	m_AT/=12;
	m_AR/=12;

	m_bN = ( m_T[1] < m_T[7] );

	float SR = m_R[m_HOT];
	float WR = m_R[m_CLD];

	if( SR >= WR*10 )
		type = 2;
	else if( WR >= SR*3 )
		type = 1;
	else
		type = 0;

	switch(type)
	{
	case 0:
		m_r = 20 * ( m_AT + 7 );
		break;
	case 1:
		m_r = 20 * ( m_AT );
		break;
	case 2:
		m_r = 20 * ( m_AT + 14 );
		break;
	}
}
